module name_mod
   use mykinds, only: qp
   private qp
include 'funr1_gfc.i90'
   use name_mod, only: name
   use name_mod, only: arg1
   use name_mod, only: X
end module cpp_mod

module funr1_sp
   use mykinds
   use output_mod
   implicit real(sp) (Q)
   private
   public funr1
   interface funr1
      module procedure funr1_template
   end interface funr1
   contains
include 'funr1.i90'
end module funr1_sp

module funr1_dp
   use mykinds
   use output_mod
   implicit real(dp) (Q)
   private
   public funr1
   interface funr1
      module procedure funr1_template
   end interface funr1
   contains
include 'funr1.i90'
end module funr1_dp

module funr1_qp
   use mykinds
   use output_mod
   implicit real(qp) (Q)
   private
   public funr1
   interface funr1
      module procedure funr1_template
   end interface funr1
   contains
include 'funr1.i90'
end module funr1_qp

module funr1_mod
   use funr1_sp
   use funr1_dp
   use funr1_qp
end module funr1_mod

program funr1_test
   use mykinds
   use output_mod
   use funr1_mod
   use cpp_mod
   implicit none
   real(sp) xr
   real(dp) xd
   real(qp) xq

   call xfinit
   xr = x
   xd = x
   xq = x
   call funr1(xr)
   call funr1(xd)
   call funr1(xq)
end program funr1_test
