module char1_output
   use mykinds, only: ck => ck1
   implicit none
   private
   public output
   interface output
      module procedure char_output
   end interface output
   contains
      subroutine char_output(x,label)
         character(LEN=*,KIND=ck) x
         character(*) label

         write(*,'(a,a,a,i0,a,a,a)') 'Name = ',label, &
            ', Type = CHARACTER, Kind = ', ck, ', Value = "', x, '"'
      end subroutine char_output
end module char1_output

module int1_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure int_output
   end interface output
   contains
include 'intr_output.i90'
end module int1_output

module int2_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik2
   implicit none
   private
   public output
   interface output
      module procedure int_output
   end interface output
   contains
include 'intr_output.i90'
end module int2_output

module int4_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik4
   implicit none
   private
   public output
   interface output
      module procedure int_output
   end interface output
   contains
include 'intr_output.i90'
end module int4_output

module int8_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik8
   implicit none
   private
   public output
   interface output
      module procedure int_output
   end interface output
   contains
include 'intr_output.i90'
end module int8_output

module log1_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure log_output
   end interface output
   contains
include 'intr_output.i90'
end module log1_output

module log2_output
   use mykinds, only: Lk => Lk2, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure log_output
   end interface output
   contains
include 'intr_output.i90'
end module log2_output

module log4_output
   use mykinds, only: Lk => Lk4, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure log_output
   end interface output
   contains
include 'intr_output.i90'
end module log4_output

module log8_output
   use mykinds, only: Lk => Lk8, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure log_output
   end interface output
   contains
include 'intr_output.i90'
end module log8_output

module sp_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure real_output
   end interface output
   contains
include 'intr_output.i90'
end module sp_output

module dp_output
   use mykinds, only: Lk => Lk1, rk => dp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure real_output
   end interface output
   contains
include 'intr_output.i90'
end module dp_output

module qp_output
   use mykinds, only: Lk => Lk1, rk => qp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure real_output
   end interface output
   contains
include 'intr_output.i90'
end module qp_output

module cmplx_sp_output
   use mykinds, only: Lk => Lk1, rk => sp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure cmplx_output
   end interface output
   contains
include 'intr_output.i90'
end module cmplx_sp_output

module cmplx_dp_output
   use mykinds, only: Lk => Lk1, rk => dp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure cmplx_output
   end interface output
   contains
include 'intr_output.i90'
end module cmplx_dp_output

module cmplx_qp_output
   use mykinds, only: Lk => Lk1, rk => qp, ik => ik1
   implicit none
   private
   public output
   interface output
      module procedure cmplx_output
   end interface output
   contains
include 'intr_output.i90'
end module cmplx_qp_output

module mytype_output
   use mykinds, only: T => mytype
   implicit none
   private
   public output
   interface output
      module procedure T_output
   end interface output
   contains
      subroutine T_output(x,label)
         type(T) x
         character(*) label

         write(*,'(a,a,a,i0,a)') 'Name = ',label, &
            ', Type = MYTYPE, Value = mytype(', x%data, ')'
      end subroutine T_output
end module mytype_output

module output_mod
   use char1_output
   use int1_output
   use int2_output
   use int4_output
   use int8_output
   use log1_output
   use log2_output
   use log4_output
   use log8_output
   use sp_output
   use dp_output
   use qp_output
   use cmplx_sp_output
   use cmplx_dp_output
   use cmplx_qp_output
   use mytype_output
   implicit none
end module output_mod
